<?php 
##
#	Project: PHPDisk Personal Edition
#	This is NOT a freeware, use is subject to license terms.
#
#	Site: http://www.phpdisk.com
#
#	$Id: plugin.func.php 303 2010-05-31 09:15:19Z along $
#
#	Copyright (C) 2008-2010 PHPDisk Team. All Rights Reserved.
#
##

if(!defined('IN_PHPDISK')) {
	exit('[PHPDisk] Access Denied');
}

function load_active_plugins(){
	$dirs = scandir(PD_PLUGINS_DIR);
	for($i=0;$i<count($dirs);$i++){
		$dir[$i] = PD_PLUGINS_DIR.$dirs[$i];
		if(is_dir($dir[$i]) && $dirs[$i] !='.' && $dirs[$i] !='..'){
			@include_once $dir[$i].'./functions.inc.php';
		}
	}
}
function get_plugin_data($plugin){
	global $db,$tpf;
	$file = PD_PLUGINS_DIR."$plugin/plugin_info.php";
	if(file_exists($file)){
		$_data = read_file($file);
		preg_match("/Plugin Name:(.*)/i",$_data,$plugin_name);
		preg_match("/Plugin URL:(.*)/i",$_data,$plugin_url);
		preg_match("/Description:(.*)/i",$_data,$plugin_desc);
		preg_match("/Author:(.*)/i",$_data,$plugin_author);
		preg_match("/Author Site:(.*)/i",$_data,$plugin_site);
		preg_match("/Version:(.*)/i",$_data,$plugin_version);
	}
	if(file_exists(PD_PLUGINS_DIR."$plugin/admin.inc.php")){
		$admin_url = urr("admincp","item=plugins&app=$plugin");
	}
	$actived = (int)@$db->result_first("select actived from {$tpf}plugins where plugin_name='$plugin' limit 1");
	$arr = array(
		'plugin_name'=>$plugin_name[1],
		'plugin_url'=>$plugin_url[1],
		'plugin_desc'=>htmlspecialchars($plugin_desc[1]),
		'plugin_author'=>$plugin_author[1],
		'plugin_site'=>$plugin_site[1],
		'plugin_version'=>$plugin_version[1],
		'admin_url'=>$admin_url,
		'plugin_dir'=>$plugin,
		'actived'=>$actived,
	);
	return $arr;
}
function display_plugin($plugin_name,$func,$param ='',$echo =1){
	global $db,$tpf;
	$plugin_name = $db->escape(trim($plugin_name));
	$actived = @$db->result_first("select actived from {$tpf}plugins where plugin_name='$plugin_name'");
	if($actived){
		if($echo){
			if(function_exists($func)){
				call_user_func($func,$param);
			}else{
				echo $param;
			}
		}else{
			return function_exists($func) && $param;
		}
	}else{
		echo "";
	}
}
function check_plugin_active_status($plugin){
	global $db,$tpf,$pub_lang;
	$actived = (int)@$db->result_first("select actived from {$tpf}plugins where plugin_name='$plugin'");
	if(!$actived){
		exit($pub_lang['plugin_not_active']);
	} 
}
function check_plugin($plugin_name){
	$dir = PD_PLUGINS_DIR.$plugin_name;
	if(is_dir($dir) && file_exists($dir.'./plugin_info.php') && $plugin_name !='.' && $plugin_name !='..'){
		$rtn = 1;
	}else{
		$rtn = 0;
	}
	return $rtn;
}

?>